####################################################
#
#	T.awk - A simple demo
#
####################################################

BEGIN {

	FS	= ","
	lastX 	= 0
	lastY 	= 0
	scale = 0.5

	of[ "00" ] = 3
	of[ "01" ] = 5


	# Start the DXF file
	F_header()
}
(1==0)	{

# The message sets the state for the next line

        for ( x = 0 ; x < 10 ; x ++ ) {
		line( 0,x*0.5,2,x*0.5,x)
		line( 0,x*0.5+0.2,2,x*0.5+0.2,x)

		text( 2.5, x*0.5, 0,  "** "+x)
	}
}




/data/ {
	line( lastX-6,lastY,(NR / 2)-6,$2*1,1)
	text( (NR / 2)-6,$2*1, 0,  "** " (NR / 2)-6 "," $2*1)

	lastX = NR / 2
	lastY = $2*1
}



/\|/{

	split($0,lr,"|")
	split(lr[2],reg,":")
	ts= substr(lr[1],length(lr[1])-20)
	split(ts,tss," " )
	if ( tss[1] != ";" ) {
		T = tss[2]

 		# print tss[2] "," reg[1]  "," reg[2] > "reg.txt"
		if ( reg[1] =="05" ) {
		  v = substr( reg[2],1,2 )
		 
		  V = of[ v ]

		  #plot line
		  line( lastT * scale  ,lastV,T * scale, lastV , 1 )
		  line( T * scale,3,T * scale, 5 , 1 )
	  	  text( T * scale,6, 90, T )

		  lastT = T
		  lastV = V
		  print T "," V > "reg.txt"
		}	
	
	}
}

/RRF     PORTB,W/ {
	split($0,lr,"|")
	split(lr[2],reg,":")
	ts= substr(lr[1],length(lr[1])-20)
	split(ts,tss," " )
	if ( tss[1] != ";" ) {
 		# print tss[2] "," reg[1]  "," reg[2] > "reg.txt"
		#if ( reg[1] =="05" ) {
		  v = substr( reg[2],1,2 )
		 
		  T = tss[2]
		  V = of[ v ]
		  lastV  = 3
		  #plot line
		  #line( lastT * scale  ,lastV,T * scale, lastV , 2 )
		  line( T * scale,2,T * scale, 6 , 1 )
	  	  text( T * scale,6, 90, T )

		  lastT = T
		  lastV = V
		  print T "," V > "reg.txt"
		#}	
	
	}
}


/BSF     PORTA,0/ {
	# found start of start bit 
	dt = 0

	line( (T+dt) * scale,1,(T+dt) * scale, 7 , 0 )
	text( (T+dt+1) * scale, 4 , 0, "start" )

	dt = dt+1.5*8192/1200

	for ( cnt = 0 ; cnt < 8 ; cnt ++ ) {
		line( (T+dt) * scale, 2,(T+dt) * scale, 6 , 4 )
		text( (T+dt) * scale, 6 , 90, " " T+dt )
		text( (T+dt+0.25 ) * scale, 4 ,  0, cnt )

		dt = dt+8192/1200
	}
	line( (T) * scale,2,(T+dt) * scale, 2 , 4 )
	line( (T) * scale,6,(T+dt) * scale, 6 , 4 )

}

/call    Intrtn;/ {

	line( (T-4)    * scale,3,(T-4+0.25) 	* scale, 5 , 4 )
	line( (T-3.25) * scale,3,(T-3.25+0.25) 	* scale, 5 , 4 )
	line( (T-3.5)  * scale,3,(T-3.5+0.25) 	* scale, 5 , 4 )
	line( (T-3.75) * scale,3,(T-3.75+0.25) 	* scale, 5 , 4 )


	text( (T-4) * scale, 1 , 0, " INT pin 0->1" )
	#text( (T-3) * scale, 3 , 0, " START" )

	# found start of start bit 
	dt = -3
	line( (T+dt)      * scale,3,(T+dt+0.25) * scale, 5 , 4 )
	line( (T+dt+0.25) * scale,3,(T+dt) * scale, 5 , 4 )
	text( (T+dt+1)    * scale,4, 0, "start" )

	dt = dt+1*8192/1200

	for ( cnt = 0 ; cnt < 8 ; cnt ++ ) {
		line( (T+dt) * scale,3,(T+dt+0.25) * scale, 5 , 4 )
		line( (T+dt+0.25) * scale,3,(T+dt) * scale, 5 , 4 )
		text( (T+dt) * scale, 6 , 90, " " T+dt )
		text( (T+dt+1) * scale, 4 ,  0, " bit " cnt )

		dt = dt+8192/1200
	}

	line( (T-4+0.25) * scale,3,(T+dt) * scale, 3 , 4 )
	line( (T-4) * scale,5,(T+dt) * scale, 5 , 4 )

}

/BCF     PORTA,0/ {
	# found start of start bit 
	dt = 0
	line( (T+dt) * scale,2,(T+dt) * scale, 6 , 5 )
	text( (T+dt) * scale,6, 90, T+dt )
	text( (T+dt) * scale, 1 , 0, "stop" )

}

END {
# draw Axis
#	line(-6,0,-1,0,0)
#	line(-6,0,-6,5,0)

#	line( 0,0,100,0,0)  # black
#	line( 0,1,100,1,1)  # red
#	line( 0,2,100,2,2)  # yellow
#	line( 0,3,100,3,3)  # green 
#	line( 0,4,100,4,4)  # cyan
#	line( 0,5,100,5,5)  # blue
#	line( 0,6,100,6,6)  # magenta
#	line( 0,7,100,7,7)  # Black
#	line( 0,8,100,8,8)  # black
#	line( 0,9,100,9,9)  # black
	# And finally tidy up the DXF file
	F_end()

}
